status-notifier-item-0.3.1.0: A wrapper over the StatusNotifierItem/libappindicator dbus specification

Safe Haskell | None
Language | Haskell2010

StatusNotifier.Host.Service

# Documentation

statusNotifierHostString :: String Source #

getBusName :: String -> String -> String Source #

data UpdateType Source #

Constructors

ItemAdded |
ItemRemoved |
IconUpdated |
OverlayIconUpdated |
StatusUpdated |
TitleUpdated |
ToolTipUpdated |

#### Instances

Instances details

Show UpdateType Source # |
Instance details Defined in StatusNotifier.Host.Service Methods showsPrec :: Int -> UpdateType -> ShowS Source # show :: UpdateType -> String Source # showList :: [UpdateType] -> ShowS Source #
Eq UpdateType Source # |
Instance details Defined in StatusNotifier.Host.Service Methods (==) :: UpdateType -> UpdateType -> Bool Source # (/=) :: UpdateType -> UpdateType -> Bool Source #

type UpdateHandler = UpdateType -> ItemInfo -> IO () Source #

data Params Source #

Constructors

Params |

Fields

- dbusClient :: Maybe Client
- uniqueIdentifier :: String
- namespace :: String
- startWatcher :: Bool
- matchSenderWhenNameOwnersUnmatched :: Bool

hostLogger :: Priority -> String -> IO () Source #

defaultParams :: Params Source #

type ImageInfo = [(Int32, Int32, ByteString)] Source #

data ItemInfo Source #

Constructors

ItemInfo |

Fields

- itemServiceName :: BusName
- itemServicePath :: ObjectPath
- itemId :: Maybe String
- itemStatus :: Maybe String
- itemCategory :: Maybe String
- itemToolTip :: Maybe (String, ImageInfo, String, String)
- iconTitle :: String
- iconName :: String
- overlayIconName :: Maybe String
- iconThemePath :: Maybe String
- iconPixmaps :: ImageInfo
- overlayIconPixmaps :: ImageInfo
- menuPath :: Maybe ObjectPath
- itemIsMenu :: Bool

#### Instances

Instances details

Show ItemInfo Source # |
Instance details Defined in StatusNotifier.Host.Service Methods showsPrec :: Int -> ItemInfo -> ShowS Source # show :: ItemInfo -> String Source # showList :: [ItemInfo] -> ShowS Source #
Eq ItemInfo Source # |
Instance details Defined in StatusNotifier.Host.Service Methods (==) :: ItemInfo -> ItemInfo -> Bool Source # (/=) :: ItemInfo -> ItemInfo -> Bool Source #

supressPixelData :: ItemInfo -> ItemInfo Source #

iconNameL :: Lens' ItemInfo String Source #

iconPixmapsL :: Lens' ItemInfo ImageInfo Source #

iconThemePathL :: Lens' ItemInfo (Maybe String) Source #

iconTitleL :: Lens' ItemInfo String Source #

itemCategoryL :: Lens' ItemInfo (Maybe String) Source #

itemIdL :: Lens' ItemInfo (Maybe String) Source #

itemIsMenuL :: Lens' ItemInfo Bool Source #

itemServiceNameL :: Lens' ItemInfo BusName Source #

itemServicePathL :: Lens' ItemInfo ObjectPath Source #

itemStatusL :: Lens' ItemInfo (Maybe String) Source #

itemToolTipL :: Lens' ItemInfo (Maybe (String, ImageInfo, String, String)) Source #

menuPathL :: Lens' ItemInfo (Maybe ObjectPath) Source #

overlayIconNameL :: Lens' ItemInfo (Maybe String) Source #

overlayIconPixmapsL :: Lens' ItemInfo ImageInfo Source #

convertPixmapsToHostByteOrder :: [(Int32, Int32, ByteString)] -> [(Int32, Int32, ByteString)] Source #

callFromInfo :: (BusName -> ObjectPath -> t) -> ItemInfo -> t Source #

data Host Source #

Constructors

Host |

Fields

- itemInfoMap :: IO (Map BusName ItemInfo)
- addUpdateHandler :: UpdateHandler -> IO Unique
- removeUpdateHandler :: Unique -> IO ()
- forceUpdate :: BusName -> IO ()

build :: Params -> IO (Maybe Host) Source #